/* P-1 factoring code, ver. 0.1 (Feb 3 2000) by Alexander Kruppa, 
   alexander.kruppa@stud.tu-muenchen.de */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "gmp.h"

#undef DEBUG
#define PM1DOOUTPUT 1
#define PM1PROGRESS 2
#define PM1NOEXPLICITE 4

/* Tries to factor N by the P-1 method. Returns 0 if no factor was found, 1 if
   a factor was found in stage 1, 2 if a factor was found in stage 2.
   The factor goes into f; f = 1 if no factor was found.
   bound1 and bound2 are the bounds for stage1 and stage2, respectively.
   Extraexponent is a number to exponentiate the root by. Useful, for example,
   for Mersenne numbers or any number whose factors are of the form 2kp+1 with
   known p.
*/

int pminus1(mpz_t f,unsigned long bound1,unsigned long bound2,mpz_t N, mpz_t extraexponent, int param);

